// Author: Dave Chambers (dlchambers@aol.com)
// BSLAHack project webpage: http://www.dlwrr.com/electronics/tools/bsla/hack/
#include "stdafx.h"
#include <Ole2.h>
#include <olectl.h>
#include "HackDefs.h"
#include "CBmp.h"
#include "Utils.h"
//#include "CIni.h"

#define HIMETRIC_INCH 2540

CBmp::CBmp()
{
	m_sz.cx = m_sz.cy = 0;
}

CBmp::~CBmp()
{
}

//CString CBmp::GetFilePath()
//{
//	CString sBmpFile = CIni::GetSetting(INI_SETTING_BMP);
//	return Utils::GetFilePath(sBmpFile);
//}

bool CBmp::LoadFromFile(LPCSTR psPath)
{
	CMemBuf buf;
	buf.LoadFromFile(psPath);
	return LoadFromMem(buf);
}

bool CBmp::LoadFromMem(CMemBuf& membuf)
{
	m_bmp.DeleteObject();
	HGLOBAL hGlobal = membuf.ToHGlobal();
	if(hGlobal)
	{
		DWORD dwSize = ::GlobalSize(hGlobal);
		LPSTREAM pstm = NULL;
		HRESULT hr = ::CreateStreamOnHGlobal(hGlobal, TRUE, &pstm);
		if(pstm)
		{
			LPPICTURE pPic = NULL;
			hr = ::OleLoadPicture(pstm, dwSize, FALSE, IID_IPicture, (LPVOID*)&pPic);
			if(pPic)
			{
				// Retrieve logical dimensions
				long lWidth=0, lHeight=0;
				pPic->get_Width(&lWidth);
				pPic->get_Height(&lHeight);

				HDC hMemDC = CreateCompatibleDC(NULL);
				if(hMemDC)
				{
					// Map logical dimensions to physical device
					int nWidth = MulDiv(lWidth, GetDeviceCaps(hMemDC, LOGPIXELSX), HIMETRIC_INCH);
					int nHeight = MulDiv(lHeight, GetDeviceCaps(hMemDC, LOGPIXELSY), HIMETRIC_INCH);
					if((nWidth>=0) && (nHeight>=0))
					{
						HDC dcScreen = GetDC(NULL);
						if(dcScreen)
						{
							HBITMAP hJpgBmp = ::CreateCompatibleBitmap(dcScreen, nWidth, nHeight);
							if(hJpgBmp)
							{
								HBITMAP hPrevBmp = (HBITMAP)::SelectObject(hMemDC, hJpgBmp);

								RECT rect = {0,0, nWidth,nHeight};
								hr = pPic->Render(hMemDC, 0, 0, nWidth, nHeight, 0, lHeight, lWidth, -lHeight, &rect);

								::SelectObject(hMemDC, hPrevBmp);

								if(SUCCEEDED(hr))
								{
									m_bmp.Attach(hJpgBmp);
									m_sz.cx = nWidth;
									m_sz.cy = nHeight;
								}
								else
									DeleteObject(hJpgBmp);
							}
							DeleteDC(dcScreen);
						}
					}
					DeleteDC(hMemDC);
				}
				pPic->Release();
			}
			pstm->Release();
		}
		::GlobalFree(hGlobal);
	}
	return HasSize();
}

bool CBmp::Draw(CDC& dc)
{
	bool ok = false;
	if(HasSize())
	{
		CDC dcMem;
		if(dcMem.CreateCompatibleDC(&dc))
		{
			CBitmap* pOldBmp = dcMem.SelectObject(&m_bmp);
			dc.BitBlt(0, 0, m_sz.cx, m_sz.cy, &dcMem, 0, 0, SRCCOPY);
			dcMem.SelectObject(pOldBmp);
			ok = true;
		}
	}
	return ok;
}

bool CBmp::HasSize()
{
	return ((m_bmp.m_hObject!=NULL) && (m_sz.cx>0) && (m_sz.cy>0));
}

bool CBmp::IsCorrectSize()
{
	return ((m_bmp.m_hObject!=NULL) && (m_sz.cx==HACKWND_CX) && (m_sz.cy==HACKWND_CY));
}
