// EditProjectsDlg.cpp : implementation file
//

#include "stdafx.h"
#include <commdlg.h>
#include "BSLAHack.h"
#include "EditProjectsDlg.h"
#include "ProjectNameDlg.h"
#include "Reg.h"


// CEditProjectsDlg dialog

#define IDT_INIT	100
#define IDT_INIT_MS	500

IMPLEMENT_DYNAMIC(CEditProjectsDlg, CDialog)

CEditProjectsDlg::CEditProjectsDlg(CWnd* pParent /*=NULL*/) :
	CDialog(CEditProjectsDlg::IDD, pParent),
	m_uCurselPinId(0),
	m_fIgnoreEvents(false),
	m_fDirty(false)
{
}

CEditProjectsDlg::~CEditProjectsDlg()
{
}

bool CEditProjectsDlg::CloseIfPossible()
{
	if(m_fDirty)
		return false;
	
	EndDialog(IDCANCEL);
	return true;
}

void CEditProjectsDlg::EditSelectedPin()
{
}

CString CEditProjectsDlg::GetSelProjectName(int* pSelidx /*= NULL*/)
{
	CString sPrjname;
	int idx = m_listProjects.GetCurSel();
	if(pSelidx)
		*pSelidx = idx;
	if(idx >= 0)
		m_listProjects.GetText(idx, sPrjname);
	return sPrjname;
}

void CEditProjectsDlg::SaveProject()
{
	CConfigProject* pPrj = GetCurrentProject();
	if(pPrj)
	{
		for(int p=0; p<NUM_PINS; p++)
		{
			LPCSTR psPin = theApp.PinNames[p];

			COLORREF rgb = m_HackWnd.GetPinColor(psPin, true);
			pPrj->SetPinColor(psPin, rgb, true);

			rgb = m_HackWnd.GetPinColor(psPin, false);
			pPrj->SetPinColor(psPin, rgb, false);

			CString txt = m_HackWnd.GetPinUserText(psPin);
			pPrj->SetPinUserText(psPin, txt);
		}
		pPrj->SetBitmap(m_HackWnd.GetMemBuf());
	}
}

void CEditProjectsDlg::LoadProject(LPCSTR psPrjName)
{
	m_fIgnoreEvents = true;
	bool loaded = false;
	CConfigProject* pPrj = theApp.Config.GetProject(psPrjName);
	if(pPrj)
	{
		for(int p=0; p<NUM_PINS; p++)
		{
			LPCSTR psPin = theApp.PinNames[p];

			COLORREF rgb = pPrj->GetPinColor(psPin, true);
			m_HackWnd.SetPinColor(psPin, rgb, true);

			rgb = pPrj->GetPinColor(psPin, false);
			m_HackWnd.SetPinColor(psPin, rgb, false);

			CString txt = pPrj->GetPinUserText(psPin);
			m_HackWnd.SetPinUserText(psPin, txt);
		}
		m_HackWnd.SetBitmap(pPrj->GetBitmapBuf());
	}
	OnClickPinRadio(pPrj ? IDC_EDIT_P0 : 0);
	m_fIgnoreEvents = false;
}

CConfigProject* CEditProjectsDlg::GetCurrentProject()
{
	return theApp.Config.GetProject(m_sCurrProjectName);
}

void CEditProjectsDlg::SetDirty(bool fDirty/*=true*/)
{
	if(!m_fIgnoreEvents)
		m_fDirty = fDirty;

	UpdateApplyButton();
}

void CEditProjectsDlg::UpdateCurrPrjButton()
{
	CWnd* pCurrPrjBtn = GetDlgItem(IDC_EDIT_SETCURRENTPRJ);
	CString sCfgPrj = theApp.Config.GetCurrentProjectName();
	CString zz; zz.Format("Set\n'%s'\nas the\r\nCurrent Project", m_sCurrProjectName);
	pCurrPrjBtn->SetWindowText(zz);
	pCurrPrjBtn->EnableWindow(sCfgPrj != m_sCurrProjectName);
}

void CEditProjectsDlg::UpdateApplyButton()
{
	GetDlgItem(IDC_EDIT_APPLY)->EnableWindow(m_fDirty || theApp.Config.IsDirty());
}

void CEditProjectsDlg::Reload()
{
	m_listProjects.ResetContent();

	CConfig& cfg = theApp.Config;
	int np = cfg.GetProjectCount();
	for(int p=0; p<np; p++)
	{
		CConfigProject* pPrj = cfg.GetProject(p);
		m_listProjects.AddString(pPrj->GetPrjName());
	}

	int idx = m_listProjects.FindStringExact(0, cfg.GetCurrentProjectName());
	m_listProjects.SetCurSel(idx);
	OnLbnSelchangeProjects();
}

void CEditProjectsDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_EDIT_PREVIEW, m_grpPreview);
	DDX_Control(pDX, IDC_EDIT_PRJ_ADD, m_btnPrjAdd);
	DDX_Control(pDX, IDC_EDIT_PRJ_DEL, m_btnPrjDel);
	DDX_Control(pDX, IDC_EDIT_PROJECTS, m_listProjects);
	DDX_Control(pDX, IDC_EDIT_PRJ_EDIT, m_btnPrjEdit);
}
//+
BEGIN_MESSAGE_MAP(CEditProjectsDlg, CDialog)
	ON_LBN_SELCHANGE(IDC_EDIT_PROJECTS, &CEditProjectsDlg::OnLbnSelchangeProjects)
	ON_CONTROL_RANGE(BN_CLICKED, IDC_EDIT_P0, IDC_EDIT_PSIN, OnClickPinRadio)
	ON_EN_CHANGE(IDC_EDIT_PIN_NAME, &CEditProjectsDlg::OnEnChangeEditPinName)
	ON_BN_CLICKED(IDC_EDIT_PIN_TXTCLR, &CEditProjectsDlg::OnBnClickedEditPinTxtclr)
	ON_BN_CLICKED(IDC_EDIT_PIN_BGCLR, &CEditProjectsDlg::OnBnClickedEditPinBgclr)
	ON_BN_CLICKED(IDC_EDIT_PRJ_ADD, &CEditProjectsDlg::OnBnClickedEditPrjAdd)
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_EDIT_PRJ_EDIT, &CEditProjectsDlg::OnBnClickedEditPrjEdit)
	ON_BN_CLICKED(IDC_EDIT_IMPORTIMG, &CEditProjectsDlg::OnBnClickedEditImportimg)
	ON_BN_CLICKED(IDC_EDIT_SETCURRENTPRJ, &CEditProjectsDlg::OnBnClickedEditSetcurrentprj)
	ON_BN_CLICKED(IDC_EDIT_APPLY, &CEditProjectsDlg::OnBnClickedEditApply)
	ON_BN_CLICKED(IDC_EDIT_CREATEIMG, &CEditProjectsDlg::OnBnClickedEditCreateimg)
	ON_BN_CLICKED(IDOK, &CEditProjectsDlg::OnBnClickedOk)
	ON_MESSAGE(WMAPP_PINCLICK, OnPinClick)
	ON_MESSAGE(WMAPP_RELOAD, OnReload)
	ON_BN_CLICKED(IDCANCEL, &CEditProjectsDlg::OnBnClickedCancel)
END_MESSAGE_MAP()

BOOL CEditProjectsDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	SetIcon(theApp.GetIcon(), TRUE);			// Set big icon
	SetIcon(theApp.GetIcon(), FALSE);		// Set small icon

	m_HackWnd.Create(m_grpPreview.m_hWnd);
	m_HackWnd.SetWindowPos(NULL, 8, 20, 0, 0, SWP_NOSIZE|SWP_NOZORDER);
	CRect rcHack;
	m_HackWnd.GetWindowRect(&rcHack);
	m_grpPreview.SetWindowPos(NULL, 0, 0, rcHack.Width()+16, rcHack.Height()+28, SWP_NOMOVE|SWP_NOZORDER);

	Reload();

	SetTimer(IDT_INIT, IDT_INIT_MS, NULL);

	return TRUE;  // return TRUE  unless you set the focus to a control
}

// CEditProjectsDlg message handlers

void CEditProjectsDlg::OnLbnSelchangeProjects()
{
	CString prjname = GetSelProjectName();

	//bool dirty = (GetCurrentProject() && GetCurrentProject()->IsDirty());
	if(m_fDirty && !m_sCurrProjectName.IsEmpty() && (prjname != m_sCurrProjectName) )
	{
		CString msg; msg.Format("Save changes to '%s'?", m_sCurrProjectName);
		if(IDYES == AfxMessageBox(msg, MB_YESNO|MB_ICONQUESTION))
			SaveProject();
	}
	SetDirty(false);
	m_sCurrProjectName = prjname;

	UpdateCurrPrjButton();

	BOOL sel = !prjname.IsEmpty();
	m_btnPrjEdit.EnableWindow(sel);
	m_btnPrjDel.EnableWindow(sel);

//	OnClickPinRadio(sel ? IDC_EDIT_P0 : 0);

	LoadProject(prjname);

	//FillUI();
}

void CEditProjectsDlg::OnClickPinRadio(UINT nID)
{
	m_uCurselPinId = nID;

	UINT uIds[] = 
	{
		IDC_EDIT_P0,
		IDC_EDIT_P1,
		IDC_EDIT_P2,
		IDC_EDIT_P3,
		IDC_EDIT_P4,
		IDC_EDIT_P5,
		IDC_EDIT_P6,
		IDC_EDIT_P7,
		IDC_EDIT_P8,
		IDC_EDIT_P9,
		IDC_EDIT_P10,
		IDC_EDIT_P11,
		IDC_EDIT_P12,
		IDC_EDIT_P13,
		IDC_EDIT_P14,
		IDC_EDIT_P15,
		IDC_EDIT_PVDD,
		IDC_EDIT_PRES,
		IDC_EDIT_PSOUT,
		IDC_EDIT_PSIN,
	};

	BOOL bEnable = (m_uCurselPinId != 0);
	for(int i=0; i<(sizeof(uIds)/sizeof(uIds[0])); i++)
	{
		CButton* pBtn = (CButton*)GetDlgItem(uIds[i]);
		pBtn->EnableWindow(bEnable);
		pBtn->SetCheck(m_uCurselPinId == uIds[i]);
	}
	
	GetDlgItem(IDC_EDIT_PIN_NAME)->EnableWindow(bEnable);
	GetDlgItem(IDC_EDIT_PIN_TXTCLR)->EnableWindow(bEnable);
	GetDlgItem(IDC_EDIT_PIN_BGCLR)->EnableWindow(bEnable);
	GetDlgItem(IDC_EDIT_CREATEIMG)->EnableWindow(bEnable);
	GetDlgItem(IDC_EDIT_IMPORTIMG)->EnableWindow(bEnable);

	CString sPinName = GetSelectedPinName();

	CString sGrpTitle; sGrpTitle.Format("Settings for pin '%s'", sPinName);
	SetDlgItemText(IDC_EDIT_GRP_PINSETTINGS, sGrpTitle);

	CString sTxt = GetCurrentProject() ? GetCurrentProject()->GetPinUserText(sPinName) : "";
	SetDlgItemText(IDC_EDIT_PIN_NAME, sTxt);
}

CString CEditProjectsDlg::GetSelectedPinName()
{
	CString sPinName;
	if(m_uCurselPinId)
		sPinName = GetCtrlText(m_uCurselPinId);
	return sPinName;
}

#define DEFAULT_TEXT_COLOR	RGB(0,0,0)
#define DEFAULT_BKGND_COLOR	RGB(0xff,0,0)


void CEditProjectsDlg::OnEnChangeEditPinName()
{
	CString sPinName = GetSelectedPinName();
	if(!sPinName.IsEmpty())
	{
		CString sTxt = GetCtrlText(IDC_EDIT_PIN_NAME);
		SetPinText(sPinName, sTxt);

		if( !sTxt.IsEmpty()
			&&
			(GetCurrentProject()->GetPinColor(sPinName, true) == NO_COLOR)
			&&
			(GetCurrentProject()->GetPinColor(sPinName, false) == NO_COLOR))
		{
			SetPinColor(sPinName, DEFAULT_TEXT_COLOR, true);
			SetPinColor(sPinName, DEFAULT_BKGND_COLOR, false);
			SetDirty();
		}
	}
}

void CEditProjectsDlg::OnBnClickedEditPinTxtclr()
{
	EditPinColor(true);
}

void CEditProjectsDlg::OnBnClickedEditPinBgclr()
{
	EditPinColor(false);
}

void CEditProjectsDlg::EditPinColor(bool fText)
{
	CString sPinName = GetSelectedPinName();
	if(!sPinName.IsEmpty())
	{
		COLORREF rgb = GetCurrentProject()->GetPinColor(sPinName, fText);
		CColorDialog dlg(rgb, CC_RGBINIT|CC_ANYCOLOR|CC_SOLIDCOLOR, this);
		if(dlg.DoModal() == IDOK)
		{
			rgb = dlg.GetColor();
			SetPinColor(sPinName, rgb, fText);
		}
	}
}

void CEditProjectsDlg::SetPinColor(LPCSTR psPinName, COLORREF rgb, bool fText)
{
	COLORREF crCurr = m_HackWnd.GetPinColor(psPinName, fText);
	if(crCurr != rgb)
	{
		m_HackWnd.SetPinColor(psPinName, rgb, fText);
		SetDirty();
	}
}

void CEditProjectsDlg::SetPinText(LPCSTR psPinName, LPCSTR psTxt)
{
	CString sCurr = m_HackWnd.GetPinUserText(psPinName);
	if(sCurr != psTxt)
	{
		m_HackWnd.SetPinUserText(psPinName, psTxt);
		SetDirty();
	}
}

void CEditProjectsDlg::OnBnClickedEditPrjAdd()
{
	bool done = false;
	do
	{
		CProjectNameDlg dlg(this, "");
		if(dlg.DoModal() == IDOK)
		{
			LPCSTR psPrjname = dlg.GetProjectName();
			if(theApp.Config.GetProject(psPrjname))
			{
				AfxMessageBox("Projaect name already exists!\r\nPlease enter a unique name.", MB_OK|MB_ICONEXCLAMATION);
			}
			else
			{
				theApp.Config.CreateProject(psPrjname);
				int idx = m_listProjects.AddString(psPrjname);
				m_listProjects.SetCurSel(idx);
				OnLbnSelchangeProjects();
				done = true;
			}
		}
		else
		{
			done = true;
		}
	} while(!done);
}

void CEditProjectsDlg::OnBnClickedEditPrjEdit()
{
	int selidx;
	CString sOrigPrjname = GetSelProjectName(&selidx);
	CProjectNameDlg dlg(this, sOrigPrjname);
	if(dlg.DoModal() == IDOK)
	{
		CString sNewName = dlg.GetProjectName();
		if(sOrigPrjname.Compare(sNewName))
		{
			GetCurrentProject()->SetPrjName(sNewName);
			m_listProjects.DeleteString(selidx);
			selidx = m_listProjects.AddString(sNewName);
			m_listProjects.SetCurSel(selidx);
			OnLbnSelchangeProjects();
			UpdateApplyButton();
		}
	}
}

void CEditProjectsDlg::OnTimer(UINT_PTR nIDEvent)
{
	if(IDT_INIT == nIDEvent)
	{
		KillTimer(IDT_INIT);
		if(m_listProjects.GetCount() < 1)
			PostMessage(WM_COMMAND, MAKEWPARAM(IDC_EDIT_PRJ_ADD, BN_CLICKED), NULL);
	}
}

void CEditProjectsDlg::OnBnClickedEditImportimg()
{
	CFileDialog fd(TRUE, ".BMP", "*.BMP", OFN_PATHMUSTEXIST|OFN_FILEMUSTEXIST, "Bitmap Files (*.BMP)\0*.BMP\0\0", this);
	OPENFILENAME& ofn = fd.GetOFN();
	ofn.lpstrTitle = "Select Bitmap to Import";
	if(fd.DoModal() == IDOK)
	{
		CString sSelImg = fd.GetPathName();
		CBmp bmp;
		if(bmp.LoadFromFile(sSelImg))
		{
			m_HackWnd.SetBitmap(sSelImg);
			SetDirty(true);
		}
	}
}

void CEditProjectsDlg::OnBnClickedEditSetcurrentprj()
{
	CString sPrjname = GetSelProjectName();
	theApp.Config.SetCurrentProjectName(sPrjname);
	SetDirty(true);
	UpdateCurrPrjButton();
	UpdateApplyButton();
}

void CEditProjectsDlg::OnBnClickedEditApply()
{
	if(this)
		this->Save();
}

void CEditProjectsDlg::Save()
{
	SaveProject();
	theApp.Config.Save();
	SetDirty(false);

	CWnd* pParent = GetParent();
	if(::IsWindow(pParent->GetSafeHwnd()))
		pParent->PostMessage(WMAPP_RELOAD);
}

HWND WaitToFindWnd(LPCSTR psClass, LPCSTR psTitle, DWORD dwWait)
{
	DWORD dwEnd = ::GetTickCount() + dwWait;
	while(::GetTickCount() < dwEnd)
	{
		HWND h = ::FindWindow(psClass, psTitle);
		if(::IsWindow(h))
			return h;
	}
	return NULL;
}

void SendTextToWnd(HWND hwnd, LPCSTR psText)
{
	::PostMessage(hwnd, EM_SETSEL, 0, (LPARAM)-1);
	while(*psText)
	{
		::PostMessage(hwnd, WM_CHAR, *psText, 0);
		psText++;
	}
}

void ClickWindow(HWND hwnd, int x, int y)
{
	LPARAM lParam = MAKELPARAM(x,y);
	::PostMessage(hwnd, WM_LBUTTONDOWN, MK_LBUTTON, lParam);
	::PostMessage(hwnd, WM_LBUTTONUP, 0, lParam);
}

void ClickButton(HWND hwnd)
{
	ClickWindow(hwnd, 3, 3);
}

#define CHKREG(z)		((z) == ERROR_SUCCESS)
void CEditProjectsDlg::OnBnClickedEditCreateimg()
{
	AfxMessageBox("BSLAHack will now open Paint with a default image.\r\nEdit the image, then save it to a .BMP file, then Import the saved file into your project.", MB_OK);

	while(WaitToFindWnd("MSPaintApp", NULL, 10))
	{
		if(AfxMessageBox("Close all instances of MSPaint", MB_RETRYCANCEL|MB_ICONINFORMATION) != IDRETRY)
			return;
	}

	CString sPath = CReg::ReadString(HKEY_CLASSES_ROOT, "Paint.Picture\\shell\\edit\\command", NULL);
	sPath.Replace("\"%1\"", "");

	STARTUPINFO si;
	ZeroMemory(&si, sizeof(STARTUPINFO));
	si.cb = sizeof(STARTUPINFO);
	PROCESS_INFORMATION pi;
	ZeroMemory(&pi, sizeof(PROCESS_INFORMATION));
	::CreateProcess(NULL, (LPSTR)(LPCSTR)sPath, NULL, NULL, FALSE, 0, NULL, NULL, &si, &pi);

	// TODO: Add your control notification handler code here
	CBitmap bmp;
	bmp.LoadBitmap(IDB_BLANK_PROJECT);

	::OpenClipboard(GetSafeHwnd());
	::EmptyClipboard() ;
	//if( pPal )
	//	::SetClipboardData (CF_PALETTE, pPal->GetSafeHandle() ) ;
	::SetClipboardData (CF_BITMAP, bmp.GetSafeHandle() ) ;
	::CloseClipboard () ;
	bmp.Detach();
	//if( pPal )
	//	pPal->Detach();

	HWND hPaint = WaitToFindWnd("MSPaintApp", NULL, 5000);
	if(hPaint)
	{
		Sleep(100);
		// Open Attributes dialog
		::PostMessage(hPaint, WM_COMMAND, 0x19333, 0);
		HWND hAttribs = WaitToFindWnd("#32770", "Attributes", 2000);
		if(hAttribs)
		{
			Sleep(100);
			HWND hWidth = ::GetDlgItem(hAttribs, 0x108);
			SendTextToWnd(hWidth, "10");
			Sleep(10);
			HWND hHeight = ::GetDlgItem(hAttribs, 0x10A);
			SendTextToWnd(hHeight, "10");
			Sleep(10);
			HWND hPixels = ::GetDlgItem(hAttribs, 0x406);
			ClickButton(hPixels);
			Sleep(10);
			HWND hColors = ::GetDlgItem(hAttribs, 0x438);
			ClickButton(hColors);
			Sleep(10);
			HWND hOK = ::GetDlgItem(hAttribs, 0x01);
			ClickButton(hOK);
		}

		// Paste
		::PostMessage(hPaint, WM_COMMAND, 0x1E125, 0);

		Sleep(1000);
		//ClickWindow(hPaint, 300, 100);
		::PostMessage(hPaint, WM_CHAR, VK_ESCAPE, 0);
	}
}

void CEditProjectsDlg::OnBnClickedOk()
{
	if(m_fDirty)
		Save();

	OnOK();
}

void CEditProjectsDlg::OnBnClickedCancel()
{
	if(m_fDirty)
	{
		int rc = AfxMessageBox("Save changes?", MB_YESNOCANCEL|MB_ICONQUESTION);
		if(IDCANCEL == rc)
			return;
		if(IDYES == rc)
			Save();
	}

	OnCancel();
}

LRESULT CEditProjectsDlg::OnPinClick(WPARAM, LPARAM lParam)
{
	LPCSTR psBS2Name = (LPCSTR)lParam;
	CString sWndTxt;
	for(UINT id=IDC_EDIT_P0; id<=IDC_EDIT_PSIN; id++)
	{
		GetDlgItem(id)->GetWindowText(sWndTxt);
		if(!sWndTxt.CompareNoCase(psBS2Name))
		{
			OnClickPinRadio(id);
			break;
		}
	}
	return 0;
}

LRESULT CEditProjectsDlg::OnReload(WPARAM, LPARAM)
{
	Reload();
	return 0;
}

