#pragma once
#include "afxwin.h"

#include "Config.h"

// CEditProjectsDlg dialog

class CEditProjectsDlg : public CDialog
{
	DECLARE_DYNAMIC(CEditProjectsDlg)

public:
	CEditProjectsDlg(CWnd* pParent = NULL);   // standard constructor
	virtual ~CEditProjectsDlg();

	bool CloseIfPossible();

// Dialog Data
	enum { IDD = IDD_EDITPROJECTS };

protected:
	CHackWnd m_HackWnd;
	bool m_fDirty;
	bool m_fIgnoreEvents;
	CString m_sCurrProjectName;

	UINT m_uCurselPinId;

	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	virtual BOOL OnInitDialog();

	void EditSelectedPin();
	CString GetSelectedPinName();
	CString GetCtrlText(UINT uIdc)
	{
		CString sTxt;
		CWnd::GetDlgItemText(uIdc, sTxt);
		return sTxt;
	}
	void EditPinColor(bool fText);
	CString GetSelProjectName(int* pSelidx = NULL);
	void SetPinColor(LPCSTR psPinName, COLORREF rgb, bool fText);
	void SetPinText(LPCSTR psPinName, LPCSTR psTxt);
	void SaveProject();
	void LoadProject(LPCSTR psPrjName);
	CConfigProject* GetCurrentProject();
	void SetDirty(bool fDirty=true);
	void UpdateCurrPrjButton();
	void UpdateApplyButton();
	void Save();
	void Reload();

	DECLARE_MESSAGE_MAP()
public:
	CStatic m_grpPreview;
	CButton m_btnPrjAdd;
	CButton m_btnPrjDel;
	CListBox m_listProjects;
	CButton m_btnPrjEdit;
	afx_msg void OnLbnSelchangeProjects();
	afx_msg void OnEnChangeEditPrjName();
	afx_msg void OnClickPinRadio(UINT nID);
	afx_msg void OnEnChangeEditPinName();
	afx_msg void OnBnClickedEditPinTxtclr();
	afx_msg void OnBnClickedEditPinBgclr();
	afx_msg void OnBnClickedEditPrjAdd();
	afx_msg void OnTimer(UINT_PTR nIDEvent);
	afx_msg void OnBnClickedEditPrjEdit();
	afx_msg void OnBnClickedEditImportimg();
	afx_msg void OnBnClickedEditSetcurrentprj();
	afx_msg void OnBnClickedEditApply();
	afx_msg void OnBnClickedEditCreateimg();
	afx_msg void OnBnClickedOk();
	afx_msg LRESULT OnPinClick(WPARAM, LPARAM);
	afx_msg LRESULT OnReload(WPARAM, LPARAM);
	afx_msg void OnBnClickedCancel();
};
