#pragma once

#include "PinCtrl.h"
#include "CBmp.h"
#include "MemBuf.h"

// CHackWnd

#define PIN_COUNT	20

class CHackWnd : public CWnd
{
	DECLARE_DYNAMIC(CHackWnd)

public:
	CHackWnd();
	virtual ~CHackWnd();

	static BOOL FindPrevWindow();
	BOOL Create(HWND hBSLA);

	void SetPinUserText(LPCSTR psBS2Name, LPCSTR psUserTxt);
	CString GetPinUserText(LPCSTR psBS2Name);

	void SetPinColor(LPCSTR psPinName, COLORREF rgb, bool fText);
	COLORREF GetPinColor(LPCSTR psPinName, bool fText);

	void SetBitmap(LPCSTR psBmpPath);
	void SetBitmap(CMemBuf& buf);
	CMemBuf& GetMemBuf()			{return m_MemBuf;}

protected:

	CPinCtrl m_pins[PIN_COUNT];
	CBmp m_bmp;
	CMemBuf m_MemBuf;

	void Reload();
	CPinCtrl* FindPin(LPCSTR psPinName);
	void FreeMem();

	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnPaint();
	afx_msg void OnDestroy();
	afx_msg LRESULT OnReload(WPARAM, LPARAM);
	DECLARE_MESSAGE_MAP()

};
