// MainWnd.cpp : implementation file
//

#include "stdafx.h"
#include "BSLAHack.h"
#include "MainWnd.h"
#include "HackDefs.h"
#include "FindBSLA.h"


#define IDT_HACK			100
#define IDT_HACK_MS			1000
#define IDT_ICONUPDATE		200
#define IDT_ICONUPDATE_MS	500
#define IDM_PRJBASE			0x9000


// CMainWnd

bool CMainWnd::s_fRegistered = false;

IMPLEMENT_DYNAMIC(CMainWnd, CWnd)

CMainWnd::CMainWnd() :
	m_pHackWnd(NULL),
	m_pEditPrjDlg(NULL),
	m_fCloseOnEditDlgExit(false)
{

}

CMainWnd::~CMainWnd()
{
}

/*static*/ BOOL CMainWnd::FindPrevWindow()
{
	HWND hPrev = ::FindWindow(HACK_EXE_WNDCLASS, HACK_EXE_WNDTITLE);
	return ::IsWindow(hPrev);
}

BOOL CMainWnd::Create()
{
	if(!s_fRegistered)
	{
		WNDCLASS wc;
		memset(&wc, 0, sizeof(WNDCLASS));
		wc.style = NULL;
		wc.lpfnWndProc = ::DefWindowProc;
		wc.hInstance = AfxGetInstanceHandle();
		wc.hIcon = theApp.LoadIcon(IDR_MAINFRAME);
		wc.hCursor = theApp.LoadStandardCursor(IDC_ARROW);
		wc.hbrBackground = (HBRUSH)::GetStockObject(WHITE_BRUSH);
		wc.lpszMenuName = NULL;
		wc.lpszClassName = HACK_EXE_WNDCLASS;
		if (!AfxRegisterClass(&wc))
		{
			TRACE0("Class Registration Failed\n");
			return FALSE;
		}
		s_fRegistered = true;
	}

	if(!CWnd::CreateEx(0, HACK_EXE_WNDCLASS, HACK_EXE_WNDTITLE, WS_OVERLAPPED, 0, 0, 200, 100, NULL, 0))
		return FALSE;

	//ShowWindow(SW_SHOW);
	return TRUE;
}

BEGIN_MESSAGE_MAP(CMainWnd, CWnd)
	ON_WM_CREATE()
	ON_WM_SETFOCUS()
	ON_WM_TIMER()
	ON_WM_DESTROY()
	ON_COMMAND(IDM_TRAY_EXIT, OnTrayExit)
	ON_COMMAND(IDM_EDITPROJECTS, OnEditProjects)
END_MESSAGE_MAP()



// CMainWnd message handlers


int CMainWnd::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	m_TrayIcon.Create(m_hWnd, WMAPP_TRAY_CALLBACK, IDI_UNHACKED, "BSLAHack");

	SetIcon(theApp.GetIcon(), TRUE);			// Set big icon
	SetIcon(theApp.GetIcon(), FALSE);		// Set small icon

	SetTimer(IDT_HACK, IDT_HACK_MS, NULL);
	SetTimer(IDT_ICONUPDATE, IDT_ICONUPDATE_MS, NULL);

	return 0;
}

void CMainWnd::OnTimer(UINT_PTR nIDEvent)
{
	if(IDT_ICONUPDATE == nIDEvent)
	{
		BOOL hacked = (m_pHackWnd != NULL);//CEvent::Exists();
		UINT idIcon = hacked ? IDI_HACKED : IDI_UNHACKED;
		LPCSTR psTip = hacked ? "BSLA is Hacked!" : "BSLA not running";
		m_TrayIcon.SetIcon(idIcon);
		m_TrayIcon.SetTipText(psTip);
	}
	else if(IDT_HACK == nIDEvent)
	{
		if(m_pHackWnd)
		{
			if(!::IsWindow(m_pHackWnd->GetSafeHwnd()))
				DestroyHackWnd();
		}
		if(!m_pHackWnd)
		{
			HWND h = FindBSLA::UnhackedWnd();
			if(h)
			{
				m_pHackWnd = new CHackWnd();
				m_pHackWnd->Create(h);
			}
		}
	}
}

void CMainWnd::OnTrayExit()
{
	if(m_pEditPrjDlg)
	{
		if(!m_pEditPrjDlg->CloseIfPossible())
		{
			m_pEditPrjDlg->SetForegroundWindow();
			AfxMessageBox("Please Save or Cancel changes before Exiting.");
			return;
		}
		m_fCloseOnEditDlgExit = true;
	}
	else
	{
		PostMessage(WM_CLOSE, 0, 0);
	}
}

void CMainWnd::OnEditProjects()
{
	if(m_pEditPrjDlg)
	{
		m_pEditPrjDlg->SetForegroundWindow();
	}
	else
	{
		m_pEditPrjDlg = new CEditProjectsDlg(this);
		m_pEditPrjDlg->DoModal();
		delete m_pEditPrjDlg;
		m_pEditPrjDlg = NULL;
		if(m_fCloseOnEditDlgExit)
			PostMessage(WM_CLOSE, 0, 0);
	}
}

void CMainWnd::OnDestroy()
{
	m_TrayIcon.Destroy();
	DestroyHackWnd();
}

LRESULT CMainWnd::DefWindowProc(UINT msg, WPARAM wParam, LPARAM lParam)
{
	if(msg == WMAPP_RELOAD)
	{
		if(m_pHackWnd)
			m_pHackWnd->PostMessage(WMAPP_RELOAD);
	}
	else if(msg == m_TrayIcon.m_uCallbackMsg)
	{
		switch(m_TrayIcon.OnTrayCallback(wParam, lParam))
		{
			case WM_RBUTTONUP:
				DisplayTrayMenu();
				break;
			case WM_LBUTTONDBLCLK:
				OnEditProjects();
				break;
		}
		return 0;
	}
	else if(msg == m_TrayIcon.m_uTaskbarCreatedMsg)
	{
		m_TrayIcon.OnTaskbarCreated();
		return 0;
	}
	else if(msg == WM_COMMAND)
	{
		WORD wID = LOWORD(wParam);
		WORD nPrjCount = theApp.Config.GetProjectCount();
		if( (wID>=IDM_PRJBASE) && (wID<(IDM_PRJBASE+nPrjCount)) )
		{
			CConfigProject* pPrj = theApp.Config.GetProject(wID-IDM_PRJBASE);
			if(pPrj)
			{
				theApp.Config.SetCurrentProjectName(pPrj->GetPrjName());
				theApp.Config.Save();
				if(m_pHackWnd)
					m_pHackWnd->PostMessage(WMAPP_RELOAD);
				if(m_pEditPrjDlg)
					m_pEditPrjDlg->PostMessage(WMAPP_RELOAD);
			}
		}
	}

	return CWnd::DefWindowProc(msg, wParam, lParam);
}

void CMainWnd::DisplayTrayMenu()
{
	CMenu menu;
	POINT pt;
	GetCursorPos(&pt);
	if(menu.LoadMenu(IDM_TRAYPOPUP))
	{
		CMenu* popup = menu.GetSubMenu(0);
		if (popup)
		{
			CMenu* pSelmenu = popup->GetSubMenu(1);
			if(pSelmenu)
			{
				UINT uIdmPrj = ID_SELECTPROJECT_PROJ1;
				pSelmenu->DeleteMenu(uIdmPrj, MF_BYCOMMAND);
				uIdmPrj = IDM_PRJBASE;
				CConfigProject* pCurrPrj = theApp.Config.GetCurrentProject();
				for(int p=0; p<theApp.Config.GetProjectCount(); p++)
				{
					CConfigProject* pPrj = theApp.Config.GetProject(p);
					//pSelmenu->ModifyMenuA(uIdmPrj, MF_BYCOMMAND, uIdmPrj, "zzz");
					pSelmenu->AppendMenuA(MF_BYCOMMAND, uIdmPrj, pPrj->GetPrjName());

					if(pPrj == pCurrPrj)
						pSelmenu->CheckMenuItem(uIdmPrj|MF_BYCOMMAND, MF_CHECKED);

					uIdmPrj++;

				}
			}

			//popup->EnableMenuItem(IDM_TRAY_EXIT, MF_BYCOMMAND|MF_ENABLED);
			popup->SetDefaultItem(IDM_TRAY_EXIT);

			SetForegroundWindow();	// So menu disappears when clicked away from it
			popup->TrackPopupMenu(TPM_BOTTOMALIGN, pt.x, pt.y, this);
			PostMessage(WM_NULL, 0, 0);	// Fix the "display the menu a 2nd time" bug, Q135788
		}
	}
}

void CMainWnd::DestroyHackWnd()
{
	if(m_pHackWnd)
	{
		m_pHackWnd->DestroyWindow();
		delete m_pHackWnd;
		m_pHackWnd = NULL;
	}
}
