// PinCtrl.cpp : implementation file
//

#include "stdafx.h"
#include "BSLAHack.h"
#include "PinCtrl.h"
#include "HackDefs.h"
//#include "CIni.h"
#include "atox.h"

// CPinCtrl
/*static*/ bool CPinCtrl::s_fRegistered = false;
/*static*/ CFont CPinCtrl::m_font;

IMPLEMENT_DYNAMIC(CPinCtrl, CWnd)

CPinCtrl::CPinCtrl() :
	m_fTracking(FALSE)
{
	if(m_font.GetSafeHandle() == NULL)
	{
		HGDIOBJ hfDflt = ::GetStockObject(DEFAULT_GUI_FONT);
		LOGFONT lf;
		GetObject(hfDflt, sizeof(lf), &lf);
		lf.lfWeight = FW_BOLD;
		HFONT hFont = CreateFontIndirect(&lf);
		m_font.Attach(hFont);
	}
}

CPinCtrl::~CPinCtrl()
{
}

BOOL CPinCtrl::Create(CWnd* pParent, int x, int y, LPCSTR psBS2PinName, UINT uIdc)
{
	if(!s_fRegistered)
	{
		WNDCLASS wc;
		memset(&wc, 0, sizeof(WNDCLASS));
		wc.style = NULL;
		wc.lpfnWndProc = ::DefWindowProc;
		wc.hInstance = AfxGetInstanceHandle();
		wc.hIcon = theApp.LoadIcon(IDR_MAINFRAME);
		wc.hCursor = theApp.LoadStandardCursor(IDC_ARROW);
		wc.hbrBackground = (HBRUSH)::GetStockObject(WHITE_BRUSH);
		wc.lpszMenuName = NULL;
		wc.lpszClassName = PINWND_WNDCLASS;
		if (!AfxRegisterClass(&wc))
		{
			TRACE0("Class Registration Failed\n");
			return FALSE;
		}
		s_fRegistered = true;
	}

	m_sBS2Name = psBS2PinName;

	Reload();

	CString sWndName("PinWnd_");
	sWndName += m_sBS2Name;
	return CWnd::CreateEx(0, PINWND_WNDCLASS, sWndName, WS_VISIBLE|WS_CHILD, x, y, CX_PINWND, CY_PINWND, pParent->GetSafeHwnd(), (HMENU)uIdc);
}

void CPinCtrl::Reload()
{
	theApp.Config.GetCurrentProjectPinInfo(m_sBS2Name, m_PinUserInfo);
	if(::IsWindow(m_hWnd))
		Invalidate();
}

BEGIN_MESSAGE_MAP(CPinCtrl, CWnd)
	ON_WM_PAINT()
	ON_WM_MOUSEMOVE()
	ON_WM_LBUTTONUP()
	ON_MESSAGE(WM_MOUSELEAVE, OnMouseLeave)
	ON_MESSAGE(WMAPP_RELOAD, OnReload)
END_MESSAGE_MAP()

// CPinCtrl message handlers

LRESULT CPinCtrl::OnMouseLeave(WPARAM, LPARAM)
{
	m_fTracking = FALSE;
	Invalidate();
	return 0;
}

void CPinCtrl::OnPaint()
{
	CPaintDC dc(this); // device context for painting
	// TODO: Add your message handler code here
	// Do not call CWnd::OnPaint() for painting messages

	CRect rc;
	GetClientRect(&rc);
	COLORREF crBg = (m_PinUserInfo.crBg == NO_COLOR) ? RGB(0x7f,0x7f,0x7f) : m_PinUserInfo.crBg;
	COLORREF crTxt = (m_PinUserInfo.crTxt == NO_COLOR) ? RGB(0,0,0) : m_PinUserInfo.crTxt;

	if(m_fTracking)
	{
		crBg = RGB(0,0,0);
		crTxt = RGB(0xFF,0xFF,0xFF);
	}
	dc.FillSolidRect(&rc, crBg);

	CString sDisp = m_fTracking ? m_sBS2Name : m_PinUserInfo.szUserText;

	if(!sDisp.IsEmpty())
	{
		CFont* pOldFont = dc.SelectObject(&m_font);
		rc.left += 2;
		rc.top += 1;
		dc.SetTextColor(crTxt);
		dc.SetBkColor(crBg);
		dc.DrawText(sDisp, &rc, DT_LEFT|DT_TOP);
		dc.SelectObject(pOldFont);
	}
}

void CPinCtrl::OnMouseMove(UINT nFlags, CPoint point)
{
	if(!m_fTracking)
	{
		TRACKMOUSEEVENT tme;
		tme.cbSize = sizeof(TRACKMOUSEEVENT);
		tme.dwFlags = TME_LEAVE;
		tme.hwndTrack = m_hWnd;
		m_fTracking = TrackMouseEvent(&tme);
		Invalidate();
	}

	CWnd::OnMouseMove(nFlags, point);
}

void CPinCtrl::OnLButtonUp(UINT, CPoint)
{
	HWND hConfig = ::FindWindow("#32770", "BSLAHack - Edit Projects");
	::PostMessage(hConfig, WMAPP_PINCLICK, 0, (LPARAM)(LPCSTR)m_sBS2Name);
}

LRESULT CPinCtrl::OnReload(WPARAM, LPARAM)
{
	Reload();
	return 0;
}
