// ProjectNameDlg.cpp : implementation file
//

#include "stdafx.h"
#include "BSLAHack.h"
#include "ProjectNameDlg.h"


// CProjectNameDlg dialog

IMPLEMENT_DYNAMIC(CProjectNameDlg, CDialog)

CProjectNameDlg::CProjectNameDlg(CWnd* pParent, LPCSTR psName) :
	CDialog(CProjectNameDlg::IDD, pParent),
	m_sName(psName)
{

}

CProjectNameDlg::~CProjectNameDlg()
{
}

void CProjectNameDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}
//+
BEGIN_MESSAGE_MAP(CProjectNameDlg, CDialog)
	ON_BN_CLICKED(IDOK, &CProjectNameDlg::OnBnClickedOk)
	ON_BN_CLICKED(IDCANCEL, &CProjectNameDlg::OnBnClickedCancel)
	ON_EN_CHANGE(IDC_PRJNAME_EDIT, &CProjectNameDlg::OnEnChangePrjnameEdit)
END_MESSAGE_MAP()


// CProjectNameDlg message handlers

BOOL CProjectNameDlg::OnInitDialog()
{
	CString sFormat;
	GetWindowText(sFormat);
	CString sTitle; sTitle.Format(sFormat, m_sName.IsEmpty() ? "Add" : "Edit");
	SetWindowText(sTitle);

	SetDlgItemText(IDC_PRJNAME_EDIT, m_sName);
	OnEnChangePrjnameEdit();

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CProjectNameDlg::OnBnClickedOk()
{
	GetDlgItemText(IDC_PRJNAME_EDIT, m_sName);
	if(theApp.Config.GetProject(m_sName))
	{
		CString msg;
		msg.Format("A Project named '%s' already exists.\r\nPlease choose a unique name.", m_sName);
		AfxMessageBox(msg, MB_OK|MB_ICONEXCLAMATION);
		return;
	}

	OnOK();
}

void CProjectNameDlg::OnBnClickedCancel()
{
	// TODO: Add your control notification handler code here
	OnCancel();
}

void CProjectNameDlg::OnEnChangePrjnameEdit()
{
	BOOL e = (GetDlgItem(IDC_PRJNAME_EDIT)->GetWindowTextLength() > 0);
	GetDlgItem(IDOK)->EnableWindow(e);
}
