#pragma once

//////////////////////////////////////////////////////////////////////
//
// This class is a thin wrapper around the ATL CRegKey wrapper.
// Although in some cases, CRegKey is missing a feature,
// such as ValueExists(), so we use the Win32 APIs directly.
//
// Things NOT found here:
//		Enumeration of keys under a parent key.
//		Enumeration of values under a key
//		QueryInfo about a key
//		Get type of a value (DWORD, String, Binary)
//		CopyKey/Value
//
//////////////////////////////////////////////////////////////////////

class CReg  
{
public:
	CReg();
	virtual ~CReg();

	static BOOL WriteDWORD(HKEY branch, LPCSTR keyName, LPCSTR valueName, DWORD value);
	static BOOL ReadDWORD(HKEY branch, LPCSTR keyName, LPCSTR valueName, DWORD& value, DWORD defaultValue=0);

	static BOOL WriteString(HKEY branch, LPCSTR keyName, LPCSTR valueName, LPCSTR strValue);

	static CString CReg::ReadString(HKEY branch, LPCSTR keyName, LPCSTR valueName);

	// Add WriteBinary() and ReadBinary() here... although CRegKey doesn't support those.
	// static BOOL WriteBinary(HKEY branch, LPCSTR keyName, LPCSTR valueName, LPBYTE value, DWORD len);
	// static BOOL ReadBinary(HKEY branch, LPCSTR keyName, LPCSTR valueName, BYTE** value, DWORD* len);

	static BOOL CreateKey(HKEY branch, LPCSTR keyName);	// Recursive

	static BOOL DeleteKey(HKEY branch, LPCSTR keyName);	// Recursive
	static BOOL DeleteValue(HKEY branch, LPCSTR keyName, LPCSTR valueName);

	static BOOL KeyExists(HKEY branch, LPCSTR keyName);
	static BOOL ValueExists(HKEY branch, LPCSTR keyName, LPCSTR valueName);
	
	static void Test();
};

